/*
 * Copyright (C) 2021-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef EXTENDED_INFO_DOMAIN_DATA_HH_E9AF9E19EFF5BBBA88ACA60FEE4A1779//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define EXTENDED_INFO_DOMAIN_DATA_HH_E9AF9E19EFF5BBBA88ACA60FEE4A1779

#include "src/keyset_metadata.hh"
#include "src/domain.hh"

#include <libfred/opcontext.hh>
#include <libfred/registrable_object/domain/info_domain.hh>
#include <libfred/registrable_object/keyset/info_keyset.hh>

#include <boost/optional.hpp>

namespace Fred {
namespace Akm {
namespace Database {

struct ExtendedInfoDomainData
{
    LibFred::InfoDomainData info_domain_data;
    ScanType scan_type;
    boost::optional<LibFred::InfoKeysetData> info_keyset_data;
};

boost::optional<ExtendedInfoDomainData> get_domain_info_from_fqdn(
        const LibFred::OperationContext&,
        const KeysetMetadata&,
        const DomainFqdn&);

} // namespace Fred::Akm::Database
} // namespace Fred::Akm
} // namespace Fred

#endif//EXTENDED_INFO_DOMAIN_DATA_HH_E9AF9E19EFF5BBBA88ACA60FEE4A1779
