/*
 * Copyright (C) 2021-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef TURN_OFF_DNSSEC_HH_D4A2ED946F46B36A75D7CF4E504801B9//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define TURN_OFF_DNSSEC_HH_D4A2ED946F46B36A75D7CF4E504801B9

#include "src/database/impl/exception.hh"
#include "src/keyset.hh"
#include "src/keyset_metadata.hh"
#include "src/keyset_reference.hh"
#include "src/logger/log_entry.hh"
#include "src/logger/impl/log_entry_type.hh"

#include <libfred/opcontext.hh>
#include <libfred/registrable_object/domain/info_domain.hh>

#include <functional>
#include <memory>

namespace Fred {
namespace Akm {
namespace Database {
namespace Impl {

struct TurnOffDnssecFailed : OperationFailed
{
    using OperationFailed::OperationFailed;
};

bool is_dnssec_turn_off_requested(const Keyset&);

void turn_off_dnssec(
        const LibFred::OperationContext&,
        const LibFred::InfoDomainData&,
        const KeysetMetadata&,
        std::function<std::unique_ptr<Logger::LogEntry<Logger::LogEntryType::akm_turn_off>>()>);

} // namespace Fred::Akm::Database::Impl
} // namespace Fred::Akm::Database
} // namespace Fred::Akm
} // namespace Fred

#endif//TURN_OFF_DNSSEC_HH_D4A2ED946F46B36A75D7CF4E504801B9
