/*
 * Copyright (C) 2021-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef DOMAIN_HH_49968B9DB1E7AC5666ABB396BBAD11A0//date "+%s.%N"|md5sum|tr "[a-f]" "[A-F]"
#define DOMAIN_HH_49968B9DB1E7AC5666ABB396BBAD11A0

#include "src/scan_type.hh"
#include "src/util/from_string.hh"

#include <boost/uuid/uuid.hpp>
#include <libstrong/type.hh>

#include <cstdint>
#include <string>

namespace Fred {
namespace Akm {

using DomainFqdn = LibStrong::Type<std::string, struct DomainFqdnTag_,
      LibStrong::Collect<LibStrong::Skill::Comparable, LibStrong::Skill::Streamable>::SuperSkill>;
using DomainId = LibStrong::Type<std::uint64_t, struct DomainIdTag_,
      LibStrong::Collect<LibStrong::Skill::Comparable, LibStrong::Skill::Streamable>::SuperSkill>;
using DomainUuid = LibStrong::Type<boost::uuids::uuid, struct DomainUuidTag_,
      LibStrong::Collect<LibStrong::Skill::Comparable, LibStrong::Skill::Streamable>::SuperSkill>;

template<>
DomainUuid from_string(const std::string&);
std::string to_string(const DomainUuid&);

} // namespace Fred::Akm
} // namespace Fred

#endif//DOMAIN_HH_49968B9DB1E7AC5666ABB396BBAD11A0
