/*
 * Copyright (C) 2021  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef __LIMITS__F0E44D716D68D4188C07E980FB467B72
#define __LIMITS__F0E44D716D68D4188C07E980FB467B72

#include <cstdlib>

namespace Fred {
namespace Akm {
namespace Limit {

// maximal allowed keyset handle length
constexpr std::size_t handle_length_max = 30;
// suffix minimum (would be generated automatically)
constexpr std::size_t handle_suffix_length_min = 8;
// prefix minimum (prefix value is taken from configuration)
constexpr std::size_t handle_prefix_length_min = 2;
// prefix maximum (some room must be left for the generated suffix)
constexpr std::size_t handle_prefix_length_max = handle_length_max - handle_suffix_length_min;

// minimum number of keys in a keyset
constexpr std::size_t keyset_size_min = 1;
// maximum number of keys in a keyset
constexpr std::size_t keyset_size_max = 10;

} // namespace Fred::Akm::Limit
} // namespace Fred::Akm
} // namespace Fred

#endif
