/*
 * Copyright (C) 2021-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */
#include "src/logger/impl/to_log_entry_property.hh"

namespace LibGrill {
namespace Logger {

template <>
LogEntryProperty to_log_entry_property(const ::Fred::Akm::DomainFqdn& _value)
{
    return LogEntryProperty{LogEntryProperty::Name{"name"}, LogEntryProperty::Value{*_value}};
}

template <>
LogEntryProperty to_log_entry_property(const ::Fred::Akm::KeysetHandle& _value)
{
    return LogEntryProperty{LogEntryProperty::Name{"keyset"}, LogEntryProperty::Value{*_value}};
}

template <>
LogEntryProperty to_log_entry_property(const ::Fred::Akm::Dnskey& _dnskey)
{
    return LogEntryProperty{LogEntryProperty::Name{"new_dns_key"}, LogEntryProperty::Value{to_string(_dnskey)}};
}

template <>
LogEntryProperty to_log_entry_property(const ::LibFred::DnsKey& _dnskey)
{
    return LogEntryProperty{LogEntryProperty::Name{"old_dns_key"}, LogEntryProperty::Value{_dnskey.to_string()}};
}

} // namespace LibGrill::Logger
} // namespace LibGrill
