/*
 * Copyright (C) 2021-2024  CZ.NIC, z. s. p. o.
 *
 * This file is part of FRED.
 *
 * FRED is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FRED is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FRED.  If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef UPDATE_HH_7E08DB6051168F1565D54C96853382BF
#define UPDATE_HH_7E08DB6051168F1565D54C96853382BF

#include "src/keyset_metadata.hh"
#include "src/logger/connection.hh"
#include "src/supervisor_connection_string.hh"

namespace Fred {
namespace Akm {

enum class DryRun
{
    no,
    yes
};

void update_acceptable_keysets(
        const KeysetMetadata&,
        const SupervisorConnectionString&,
        const Logger::ConnectionString&,
        DryRun = DryRun::no);

} // namespace Fred::Akm
} // namespace Fred

#endif
